<?php

//run only one of the Create/Modify functions at a time and check up the results after every step
//function CheckIfIsdnOrAnalog runs automatically; it doesn't need to be called from terminal
//Sip account and PSTN Group must exist

class DialplanCest 
{ 
    public function CheckIfIsdnOrAnalog(AcceptanceTester $I)
    {
	try {
    		$I->see('ISDN');
    		// Continue to do this if it's present
    		$groupName = 'IsdnGroup';
		return $groupName;
	} catch (Exception $e) {
    		// Do this if analog is not present.
    		$groupName = 'AnalogGroup';
		return $groupName;
	}
    } 

    public function DialplanCreate(AcceptanceTester $I)
    {
	$I->loginSuccessfully($I);
	$groupName = $this->CheckIfIsdnOrAnalog($I);
        $I->click("Dialplan");
	//Path problem with Codeception
	$I->amOnPage('/app/berogui/index.php?m=Dialplan');
	$I->see("Direction");
	$I->click("Add");

	switch ($groupName) {
    		case "AnalogGroup":
			$I->sendAjaxPostRequest('/app/berogui/modules/Dialplan/dialplan_submit.php', array(
			'fromDirection' => 'sip',
			'toDirection' => 'analog',
			'name=matchType' => 'Any',
			'fromIdSip' => '.*',
			'toAnalog' => 'analogGroup',
    			'dest' => '(.*)',
			'src' => '(.*)',
			'activ' => 'true',
			'reverse' => true
			), 'submit');
			break;
    		case "IsdnGroup":
			$I->sendAjaxPostRequest('/app/berogui/modules/Dialplan/dialplan_submit.php', array(
			'fromDirection' => 'sip',
			'toDirection' => 'isdn',
			'name=matchType' => 'Any',
			'fromIdSip' => '.*',
			'toIsdn' => 'isdnGroup',
    			'dest' => '(.*)',
			'src' => '(.*)',
			'activ' => 'true',
			'reverse' => true
			), 'submit');
			break;
	}
	//2S02FXS needs an extra step for analog
	if ($I->moduleName == '2S02FXS') {
		$I->sendAjaxPostRequest('/app/berogui/modules/Dialplan/dialplan_submit.php', array(
		'fromDirection' => 'sip',
		'toDirection' => 'analog',
		'name=matchType' => 'Any',
		'fromIdSip' => '.*',
		'toAnalog' => 'analogGroup',
    		'dest' => '(.*)',
		'src' => '(.*)',
		'activ' => 'true',
		'reverse' => true
		), 'submit');
	}
    } 

    public function  DialplanModify(AcceptanceTester $I)
    {
	$I->loginSuccessfully($I);
	$groupName = $this->CheckIfIsdnOrAnalog($I);
        $I->click("Dialplan");
	//Path problem with Codeception
	$I->amOnPage('/app/berogui/index.php?m=Dialplan');
	$I->see("Direction");
	//$I->click("//a[contains(@href,'modules/Dialplan/dialplan_popup.php?id=1')]");
	//Set Destination (111)
	switch ($groupName) {
    		case "AnalogGroup":
			$I->sendAjaxPostRequest('/app/berogui/modules/Dialplan/dialplan_submit.php?id=1', array(
			'fromDirection' => 'sip',
			'toDirection' => 'analog',
			'name=matchType' => 'Any',
			'fromIdSip' => '.*',
			'toAnalog' => 'analogGroup',
    			'dest' => '(111)',
			'src' => '(.*)',
			'activ' => 'true',
			'id_upd' => 1
			), 'submit');
			break;
    		case "IsdnGroup":
			$I->sendAjaxPostRequest('/app/berogui/modules/Dialplan/dialplan_submit.php?id=1', array(
			'fromDirection' => 'sip',
			'toDirection' => 'isdn',
			'name=matchType' => 'Any',
			'fromIdSip' => '.*',
			'toIsdn' => 'isdnGroup',
    			'dest' => '(111)',
			'src' => '(.*)',
			'activ' => 'true',
			'id_upd' => 1
			), 'submit');
			break;
	}

	//2S02FXS extra step for analog

	if ($I->moduleName == '2S02FXS') {
		$I->amOnPage('/app/berogui/index.php?m=Dialplan');
		$I->click("//a[contains(@href,'modules/Dialplan/dialplan_popup.php?id=3')]");
		$I->sendAjaxPostRequest('/app/berogui/modules/Dialplan/dialplan_submit.php?id=3', array(
			'fromDirection' => 'sip',
			'toDirection' => 'analog',
			'name=matchType' => 'Any',
			'fromIdSip' => '.*',
			'toAnalog' => 'analogGroup',
    			'dest' => '(111)',
			'src' => '(.*)',
			'activ' => 'true',
			'id_upd' => 3
			), 'submit');

	}

    }  

}
?>
